include:
  - local: "ci-pipeline/argocd/connect.template.yml"
  - local: "cd-pipeline/deploy/argocd.template.yml"

stages:
  - test
  - deploy

Connect and Test k8s:
  image: alpine:latest
  stage: test
  variables:
    K8S_TOKEN: $DO_K8S_TOKEN
  extends: .connect.digital-ocean.k8s
  only:
    - merge_requests
    - main
    - develop

ArgoCD Project:
  image: docker:stable
  stage: deploy
  extends: .argocd.deploy
  variables:
    TYPE: project
  needs:
    - "Connect and Test k8s"
  only:
    - merge_requests
    - main
    - develop

ArgoCD Repository:
  image: docker:stable
  stage: deploy
  extends: .argocd.deploy
  variables:
    TYPE: repository
  needs:
    - "ArgoCD Project"
  only:
    - merge_requests
    - main
    - develop

ArgoCD Application:
  image: docker:stable
  stage: deploy
  extends: .argocd.deploy
  variables:
    TYPE: application
  needs:
    - "ArgoCD Repository"
  only:
    - merge_requests
    - main
    - develop
